# morse_tms.rb
#
# Copyright (C) September 7, 2014
#
# Author: Abbas Taghiloei AKA MR.0x41 <sir.0x41@gmail.com>
#
# == License
#
# The MIT License (MIT)
#
# Copyright (c) [2014] [morse_tms v 0.1 Ruby Gem]
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#

raise "Please, use ruby 2.0.0 or later." if RUBY_VERSION < "2.0.0"

require "Win32API"

Beep = Win32API.new("kernel32", "Beep", ["I", "I"], 'v')
def morsound freq, duration
	Beep.call(freq, duration)
end
		
def morsehash
	mohash = Hash.new
	mohash = {	'"' => '---...',
				',' => '--..--',
				'?' => '..--..',
				'@' => '.--.-.',
				'-' => '-....-',
				'0' => '-----',
				'5' => '.....',
				'1' => '.----',
				'2' => '..---',
				'3' => '...--',
				'4' => '....-',
				'6' => '-....',
				'7' => '--...',
				'8' => '---..',
				'9' => '----.',
				'/' => '-..-.',
				'=' => '-...-',
				'B' => '-...',
				'C' => '-.-.',
				'F' => '..-.',
				'J' => '.---',
				'L' => '.-..',
				'P' => '.--.',
				'Q' => '--.-',
				'V' => '...-',
				'X' => '-..-',
				'Y' => '-.--',
				'Z' => '--..',
				'H' => '....',
				'D' => '-..',
				'G' => '--.',
				'K' => '-.-',
				'R' => '.-.',
				'U' => '..-',
				'W' => '.--',
				'S' => '...',
				'O' => '---',
				'M' => '--',
				'I' => '..',
				'A' => '.-',
				'N' => '-.',
				'T' => '-',
				'E' => '.',
				}
	@morsevalue, @morsekeys = Array.new
	@morsevalue = mohash.values
	@morsekeys = mohash.keys
end
	
def string_to_morse(str)
	if str == nil
		return 0
	else
		str = str.upcase
		str.gsub!(" ", "  ")
		i = 0
		while i < @morsevalue.size
			str.gsub!("#{@morsekeys[i]}", "#{@morsevalue[i]} ")
			i = i + 1
		end
	end
	return str
end
	
def morse_to_string(mrs)
	if mrs == nil
		return 0
	else
		i = 0
		while i < @morsevalue.size
			mrs.gsub!("#{@morsevalue[i]}", "#{@morsekeys[i]}")
			i = i + 1
		end
	end
	return mrs
end
	
def morse_to_voice(mrs)
	if mrs == nil
		return 0
	else
		i = 0
		while i < mrs.size
			if mrs[i] == '.'
				morsound 1000, 200
			elsif mrs[i] == '-'
				morsound 1000, 600
			elsif mrs[i] == ' '
				sleep 0.25
			end
			i = i + 1
		end
	end
end

morsehash()